<template>
    <div class="form">
        <div class="form__title text-center">
            <h4>Напишите мне</h4>
            <p>Для покупки или уточнения деталей свяжитесь со мной наиболее удобным способом</p>
        </div>

        <MyBtn class="my-btn-form flex justify-center items-center" @click="whatsup">WHATS UP</MyBtn>
        <MyBtn class="my-btn-form flex justify-center items-center" @click="insta">INSTAGRAM</MyBtn>

        <Transition name="slide-fade">
            <div class="form__email" v-show="showForm">
                <div class="form__email-fio">
                    <input type="name" placeholder="ФИО" v-model="fio" :class="{ 'invalid-input': !fioValid }">
                </div>
                <div class="form__email-contacts flex justify-between">
                    <input type="email " placeholder="Email" v-model="email" :class="{ 'invalid-input': !emailValid }">
                    <input type="tel" placeholder="Телефон" v-model="tel" :class="{ 'invalid-input': !telValid }">
                </div>
                <div class="form__email-info flex justify-between">
                    <input type="text" :value="title" disabled="true">
                    <textarea placeholder="Текст сообщения" v-model="textarea"
                        :class="{ 'invalid-input': !textareaValid }"></textarea>
                </div>
                <MyBtn class="my-btn-form-sumbmit flex justify-center items-center" @click="submitForm"
                    v-show="isAnyFieldFilled">ОТПРАВИТЬ
                </MyBtn>
            </div>
        </Transition>
        <MyBtn class="my-btn-form flex justify-center items-center" @click="showFormClick" v-show="!formFilled">EMAIL
        </MyBtn>

        <router-link :to="`/CardPages`" class="self-end my-btn-form-end flex justify-center items-center">
            <MyBtn>НАЗАД</MyBtn>
        </router-link>

    </div>
</template>

<script>
import { watch } from 'vue';
import MyBtn from '../elements/MyBtn.vue';
export default {
    data() {
        return {
            showForm: false,
            title: 'Лот' + " " + this.$route.params.title,
            fio: '',
            email: '',
            tel: '',
            textarea: '',
            fioValid: true,
            emailValid: true,
            telValid: true,
            textareaValid: true,
            formFilled: false
        }
    },
    methods: {
        showFormClick() {
            if (this.showForm === true) {
                this.showForm = false
            }
            else {
                this.showForm = true
            }
        },
        submitForm() {
            let isFormValid = true;

            this.fioValid = this.fio !== '';
            this.emailValid = this.email !== '';
            this.telValid = this.tel !== '';
            this.textareaValid = this.textarea !== '';

            isFormValid = this.fioValid && this.emailValid && this.telValid && this.textareaValid;

            if (!isFormValid) {

            } else {
                console.log(`
                    Картина: ${this.title} 
                    ФИО: ${this.fio} 
                    Email: ${this.email}
                    Телефон: ${this.tel} 
                    Сообщение: ${this.textarea}
                `);

                this.fio = '';
                this.email = '';
                this.tel = '';
                this.textarea = '';
            }
        },
        insta() {
            window.location.href = 'https://www.instagram.com/minimastudio.ru?igsh=MWRiMjkwMnp6cWlyZw=='
        },
        whatsup() {
            window.location.href = 'https://Wa.me/79897123271'
        },
    },computed: {
        isAnyFieldFilled() {
            return this.fio.trim() !== '' || this.email.trim() !== '' || this.tel.trim() !== '' || this.textarea.trim() !== '';
        }
    },
    watch: {
        isAnyFieldFilled(newValue) {
            this.formFilled = newValue;
        }
    },
  
        components: {
        MyBtn
    }
}
</script>

<style scoped>
.slide-fade-enter-active,
.slide-fade-leave-active {
    transition: opacity 0.5s ease, transform 0.3s ease;
}

.slide-fade-enter-from,
.slide-fade-leave-to {
    opacity: 0;
    transform: translateY(-10px);
}

.slide-fade-enter-to,
.slide-fade-leave-from {
    opacity: 1;
    transform: translateY(0);

}

.invalid-input {
    border: 1px solid red;
}

.my-btn-form-sumbmit {
    color: #F1F1EF;
    border-radius: 10px;
    background: #55524D;
    max-width: 400px;
    width: 100%;
    height: 40px;
    margin-top: 20px;
    font-size: 15px;
}

.form__email-fio input {
    max-width: 400px;
    width: 100%;
}

.form__email-contacts input {
    max-width: 190px;
    width: 100%;
}

.form__email-info textarea {
    max-width: 400px;
    width: 100%;
    height: 150px;
    margin-top: 20px;
    padding: 18px 10px;
    color: #AFAFAF;
    font-size: 12px;
    border-radius: 10px;
    border: 1px solid #383838;
    background: rgba(40, 40, 40, 0.00);
    resize: none;
    overflow: auto;
}

.form__email-info input {
    padding: 0;
    max-width: 99px;
    width: 100%;
    color: #6B6B6B;
    border: none;
    background: none;
    position: absolute;
    top: 8px;
    right: -9px;
}

.form__email-info {
    position: relative;
}

input {
    margin-top: 20px;
    padding: 11px 10px;
    color: #AFAFAF;
    font-size: 12px;
    border-radius: 10px;
    border: 1px solid #383838;
    background: rgba(40, 40, 40, 0.00);
}

.form {
    padding: 40px 0;
    font-family: "Zen Antique Soft";
    display: flex;
    flex-direction: column;
    max-width: 400px;
    width: 100%;
    margin: 0 auto;
    min-height: 100vh;
    justify-content: center;
}

h4 {
    color: #383838;
    font-size: 36px;
    font-style: normal;
    letter-spacing: 1.2px;
}

.my-btn-form {
    margin-top: 20px;
    border-radius: 10px;
    background: #383838;
    max-width: 400px;
    width: 100%;
    height: 40px;
    color: #F1F1EF;
    font-size: 15px;
    cursor: pointer;
}

.my-btn-form-end {
    border-radius: 10px;
    border: 1px solid #383838;
    max-width: 400px;
    width: 100%;
    height: 40px;
    background: rgba(56, 56, 56, 0.00);
    margin-top: 20px;
    cursor: pointer;
    margin-bottom: 20px;
}

p {
    margin: 5px 0 20px;
    color: #6B6B6B;
    font-size: 15px;
}



@media (max-width: 767.98px) {
    .form {
        padding: 30px 34px;
        justify-content: start;
    }

    h4 {
        font-size: 20px;
        letter-spacing: 0.6px;
        margin: 20px 0 0;
    }

    p {
        margin: 5px 0 5px;
        color: #6B6B6B;
        font-size: 11px;

    }

    input {
        margin-top: 15px;
        padding: 10px;
        font-size: 10px;
        height: 37px;
    }

    .my-btn-form,
    .my-btn-form-end,
    .my-btn-form-sumbmit {
        height: 37px;
        font-size: 12px;
        margin-top: 15px;
    }

    .form__email-contacts,
    .form__email-contacts input {
        flex-direction: column;
        max-width: 400px;
    }

    .form__email-info textarea {
        max-width: 400px;
        width: 100%;
        height: 150px;
        margin-top: 15px;
        padding: 20px 10px;
        color: #AFAFAF;
        font-size: 10px;

    }

    .form__email-info input {
        height: 14px;
        top: 6px;
        right: 10px;
        font-size: 10px;
    }

}
</style>